import IBounds from "../interfaces/iBounds";
import Point3D from "./point3D";
export default class Bounds extends Point3D implements IBounds {
    constructor(...values: any[]);
    protected _setSchema(): void;
    reset(): this;
    readonly previous: number[];
    protected readonly _arrayPrevious: number[];
    position: number[];
    size: number[];
    pivot: number[];
    scale: number[];
    scaleAll: number;
    pivotX: number;
    pivotY: number;
    pivotZ: number;
    scaleX: number;
    scaleY: number;
    scaleZ: number;
    leftUnscaled: number;
    left: number;
    rightUnscaled: number;
    right: number;
    topUnscaled: number;
    top: number;
    bottomUnscaled: number;
    bottom: number;
    frontUnscaled: number;
    front: number;
    readonly backUnscaled: number;
    readonly back: number;
    readonly topLeftFrontUnscaled: number[];
    readonly topRightFrontUnscaled: number[];
    readonly bottomLeftFrontUnscaled: number[];
    readonly bottomRightFrontUnscaled: number[];
    readonly topLeftFront: number[];
    readonly topRightFront: number[];
    readonly bottomLeftFront: number[];
    readonly bottomRightFront: number[];
    readonly topLeftBackUnscaled: number[];
    readonly topRightBackUnscaled: number[];
    readonly bottomLeftBackUnscaled: number[];
    readonly bottomRightBackUnscaled: number[];
    readonly topLeftBack: number[];
    readonly topRightBack: number[];
    readonly bottomLeftBack: number[];
    readonly bottomRightBack: number[];
    widthUnscaled: number;
    width: number;
    heightUnscaled: number;
    height: number;
    depthUnscaled: number;
    depth: number;
    readonly centerXUnscaled: number;
    readonly centerYUnscaled: number;
    readonly centerZUnscaled: number;
    readonly centerX: number;
    readonly centerY: number;
    readonly centerZ: number;
    radiusUnscaled: number;
    radius: number;
    readonly isEmpty: boolean;
    readonly clone: Bounds;
    setPrevious(values?: number[]): this;
    intersects(cube: IBounds): boolean;
    has(cube: IBounds): boolean;
    canFit(cube: IBounds): boolean;
    static readonly empty: Bounds;
    static readonly schema: string[];
    static getArray(...args: number[]): number[];
}
